## What do I need to know to help?

If you are looking to help with a code contribution our project uses _Javascript, Fastify_. If you don't feel ready to make a code contribution yet, no problem!

If you are interested in making a code contribution and would like to learn more about the technologies that we use, check out the list below.

## How do I make a contribution?

Never made an open source contribution before? Wondering how contributions work in the in our project? Here's a quick rundown!

1.  Find an issue that you are interested in addressing or a feature that you would like to add.
2.  Fork the repository associated with the issue to your local GitHub organization. This means that you will have a copy of the repository under `your-gitlab-username/repository-name`.
3.  Clone the repository to your local machine using `git clone https://gitlab.com/atixlabs-oss/agua/backend.git`
4.  Create a new branch for your fix using `git checkout -b branch-name-here`.
5.  Make the appropriate changes for the issue you are trying to address or the feature that you want to add. Also, add the related unit tests
6.  Use `git add insert-paths-of-changed-files-here` to add the file contents of the changed files to the "snapshot" git uses to manage the state of the project, also known as the index.
7.  Use `git commit -m "Insert a short message of the changes made here"` to store the contents of the index with a descriptive message. The commit message should be compliant with [conventional commits](https://www.conventionalcommits.org).
8.  Push the changes to the remote repository using `git push origin branch-name-here`.
9.  Submit a merge request to the upstream repository.
10. Title the merge request with a short description of the changes made and the issue or bug number associated with your change. For example, you can title an issue like so "Added more log outputting to resolve #4352".
11. In the description of the merge request, explain the changes that you made, any issues you think exist with the merge request you made, and any questions you have for the maintainer. It's OK if your merge request is not perfect (no merge request is), the reviewer will be able to help you fix any problems and improve it!
12. Wait for the merge request to be reviewed by a maintainer.
13. Make changes to the merge request if the reviewing maintainer recommends them.
14. Celebrate your success after your merge request is merged!

## Where can I go for help?

If you need help, you can ask questions on our mailing list.

## What does the Code of Conduct mean for me?

Our Code of Conduct means that you are responsible for treating everyone on the project with respect and courtesy regardless of their identity. If you are the victim of any inappropriate behavior or comments as described in our Code of Conduct, we are here for you and will do the best to ensure that the abuser is reprimanded appropriately, per our code.
